﻿Imports rscmwgprf_power_measurement_example.InstrumentDriversVB

Public Class rscmwgprf_power_measurement_example
    Private instrument As rscmwgprf
    Private frequency As Double
    Private level As Double
    Private result(0 To 1) As Double
    Private rel As Integer
    Private count As Integer

    Private Sub measBtn_Click(sender As System.Object, e As System.EventArgs) Handles measBtn.Click        

        frequency = Convert.ToDouble(frequencyTB.Text)
        level = Convert.ToDouble(levelTB.Text)        
        Try
            instrument = New rscmwgprf(ResourceDescriptor.Text, True, True)

            ' generator(setup)
            instrument.ConfigureGeneratorMode(1, rscmwgprfConstants.GenmodeCw)
            instrument.ConfigureGeneratorStandAloneScenario(1, rscmwgprfConstants.GeneratorConnRf1c, rscmwgprfConstants.GeneratorSalConvTx1)
            instrument.ConfigureGeneratorFrequencyLevel(1, frequency, -10.0)

            ' detector setup
            instrument.ConfigureAnalyzerStandAloneScenario(1, rscmwgprfConstants.AnalyzerConnRf1c, rscmwgprfConstants.AnalyzerSalConvRx1)
            instrument.ConfigureAnalyzer(1, level, 0.0, frequency)

            ' measurement setup
            instrument.ConfigurePwrMeasStatistics(1, rscmwgprfConstants.RepetitionSingle, 20)
            instrument.ConfigurePwrMeasTrigger(1, "Free Run", rscmwgprfConstants.TriggerCont, -30.0, 0.0001, rscmwgprfConstants.TrigmodeOnce, 1.0)

            instrument.ConfigureGeneratorState(1, True)

            ' init measure
            instrument.PwrMeasInit(1)

            ' fetch results
            instrument.FetchPwrMeas(1, rscmwgprfConstants.ResultCurrent, rscmwgprfConstants.DetectorRms, 1, rel, result, count)
            powerRMSTB.Text = result(0).ToString()

            instrument.FetchPwrMeas(1, rscmwgprfConstants.ResultCurrent, rscmwgprfConstants.DetectorMin, 1, rel, result, count)
            powerMinTB.Text = result(0).ToString()

            instrument.FetchPwrMeas(1, rscmwgprfConstants.ResultCurrent, rscmwgprfConstants.DetectorMax, 1, rel, result, count)
            powerMaxTB.Text = result(0).ToString()
        Catch ex As System.Runtime.InteropServices.ExternalException
            Dim message As String
            message = "Instrument Status Error: " + ex.Message + Environment.NewLine
            message += "Instrument Error Code: " + ex.Message + ex.ErrorCode.ToString("X")
            MessageBox.Show(message)
        End Try


    End Sub
End Class
